## ros-kinetic-csm 1.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4)
cmake_policy(SET CMP0004 OLD)
SET(local_prefix "local_config/local-")
FIND_PROGRAM(HOSTNAME hostname PATHS $ENV{PATH})
IF(HOSTNAME)
	# TODO: hostname does not accept -s on cygwin
	IF(CYGWIN OR WIN32)
		SET(hostname_params "")
	ELSE(CYGWIN OR WIN32)
		SET(hostname_params "-s")
	ENDIF(CYGWIN OR WIN32)
	
	EXEC_PROGRAM(${HOSTNAME} ARGS ${hostname_params} OUTPUT_VARIABLE host)

	SET(local "${local_prefix}${host}.cmake")
	
	SET(extension "$ENV{CSM_CONF}")
	IF(extension)
		SET(local "${local_prefix}${host}-${extension}.cmake")
	ENDIF(extension)
	
	IF(EXISTS ${local})
		MESSAGE(STATUS "Including local configuration ${local}.")
		INCLUDE(${local})
	ELSE(EXISTS ${local})
		MESSAGE(STATUS "Create a file named '${local}' if you want to add options.")
	ENDIF(EXISTS ${local})
ELSE(HOSTNAME)
	MESSAGE(STATUS "Program `hostname` not found. (don't worry)")
ENDIF(HOSTNAME)


ENABLE_TESTING()
SUBDIRS(sm)

=== docs/Makefile ===

#maruku=ruby -I~/maruku/lib ~/maruku/bin/maruku
maruku=maruku

out=csm_manual.pdf csm_manual.html

all: $(out)
	cp $(out) ..

src=\
  preamble.txt \
  inline_style.css \
  readme.txt \
  install.txt \
  install-ruby.txt \
  laserdata.txt \
  formats.txt \
  examples.txt \
  embedding.txt


%: tmp_%
	cp $< $@

csm_manual.txt: $(src)
	cat $^ > $@

%.pdf: %.txt
	$(maruku) --pdf -o $@ $<

%.html: %.txt
	$(maruku) --html $<

clean: 
	rm $(out)
	
copy: out/csm_manual.html
	cp $< ../CSM_MANUAL.html

=== docs/example-linking-make/Makefile ===
CSM_FLAGS=`pkg-config --libs --cflags csm`

myprogram: myprogram.c
	gcc $(CSM_FLAGS) -o myprogram myprogram.c

=== sm/csm/CMakeLists.txt ===
SET(csm_sources
	laser_data.c
	laser_data_fisher.c
	laser_data_json.c
	laser_data_carmen.c
	laser_data_load.c
	laser_data_drawing.c
	laser_data_bbox.c
	
	json_journal.c
	math_utils.c
	math_utils_gsl.c
	utils.c
	orientation.c
	clustering.c
	logging.c
	sm_options.c
	
	icp/icp.c
	icp/icp_loop.c
	icp/icp_corr_dumb.c
	icp/icp_corr_tricks.c
	icp/icp_outliers.c
	icp/icp_covariance.c
	icp/icp_debug.c
	
	mbicp/mbicp_interface.c      
	mbicp/MbICP.c      
	mbicp/calcul.c     
	mbicp/percolate.c  
	mbicp/sp_matrix.c
	hsm/hsm.c
	hsm/hsm_interface.c
	
	gpm/gpm.c
)

IF(CAIRO_FOUND)
	SET(csm_sources ${csm_sources} laser_data_cairo.c)
ENDIF(CAIRO_FOUND)


foreach(dir . hsm mbicp icp gpm structprior)
FILE(GLOB csm_headers "${dir}/*.h")
foreach(header ${csm_headers} )
 	INSTALL(FILES ${header} DESTINATION include/csm/${dir})
endforeach(header ${csm_headers})
endforeach(dir . csm)

=== sm/pkg-config/CMakeLists.txt ===
CONFIGURE_FILE(csm.pc.in ${CMAKE_CURRENT_SOURCE_DIR}/csm.pc @ONLY)

INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/csm.pc
	DESTINATION lib/pkgconfig)

=== misc/tests/failure1/Makefile ===

only_corr=-sens_countour_draw 0 -ref_countour_draw 0 -sens_points_draw 0 -ref_points_draw 0 -sens_rays_draw 0 -ref_rays_draw 0 -write_info 1

all:
	json_extract -nth 0 -in stallo2.log -out stallo2-0.json
	json_extract -nth 1 -in stallo2.log -out stallo2-1.json
	log2pdf -config hokuyo.config -use odometry -in stallo2-0.json
	log2pdf -config hokuyo.config -use odometry -in stallo2-1.json
	log2pdf -config hokuyo.config -use odometry -in stallo2.log -distance_xy 0
	sm2 -restart 0 -in stallo2.log -out stallo2_plicp.log -max_iterations 10 -file_jj stallo2_plicp.journal
	sm_animate $(only_corr) -in  stallo2_plicp.journal -out 'stallo2_plicp_%02d.pdf'
	sm2 -restart 0  -in stallo2.log -out stallo2_icp.log  -use_point_to_line_distance  0 -max_iterations 10 -file_jj stallo2_icp.journal
	sm_animate $(only_corr) -in  stallo2_icp.journal -out 'stallo2_icp_%02d.pdf'
	sm2    -in stallo2.log -out stallo2_gpm.log  -algo 1 -file_jj stallo2_gpm.journal
	log2pdf -config hokuyo.config -use estimate -in stallo2_gpm.log
	sm2  -restart 0 -max_correspondence_dist  0.2 -in stallo2.log -out stallo2_plicp2.log -max_iterations 10 -file_jj stallo2_plicp2.journal
	sm_animate $(only_corr) -in  stallo2_plicp2.journal -out 'stallo2_plicp2_%02d.pdf'
	sm2  -restart 0 -max_correspondence_dist  0.2 -in stallo2.log -out stallo2_icp2.log -max_iterations 10 -file_jj stallo2_icp2.journal  -use_point_to_line_distance  0
	sm_animate $(only_corr) -in  stallo2_icp2.journal -out 'stallo2_icp2_%02d.pdf'

=== sm/lib/egsl/CMakeLists.txt ===

SET(egsl_sources 
	egsl.c 
	egsl_ops.c
	egsl_conversions.c
	egsl_misc.c
)

ADD_LIBRARY(egsl STATIC ${egsl_sources})

ADD_EXECUTABLE(egsl_test egsl_test.c)
TARGET_LINK_LIBRARIES(egsl_test egsl  ${GSL_LIBRARIES})

ADD_EXECUTABLE(egsl_test_allocation egsl_test_allocation.c)
TARGET_LINK_LIBRARIES(egsl_test_allocation egsl  ${GSL_LIBRARIES})


# installation

FILE(GLOB headers "*.h")
INSTALL(FILES ${headers} DESTINATION include/egsl)
INSTALL(TARGETS egsl ARCHIVE DESTINATION lib)

=== sm/lib/gpc/CMakeLists.txt ===

SET(gpc_sources
	gpc.c
	gpc_utils.c
)

ADD_LIBRARY(gpc STATIC  ${gpc_sources})

=== sm/lib/options/CMakeLists.txt ===
SET(options_sources options.c options_interface.c )
ADD_LIBRARY(options STATIC ${options_sources})

ADD_EXECUTABLE(test_options test_options.c)
TARGET_LINK_LIBRARIES(test_options options)


# installation

FILE(GLOB headers "*.h")
INSTALL(FILES ${headers} DESTINATION include/options)
INSTALL(TARGETS options ARCHIVE DESTINATION lib)

=== debian/changelog ===
ros-kinetic-csm (1.0.2-1xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Isaac I.Y. Saito <130s@2000.jukuin.keio.ac.jp>  Sun, 12 Mar 2017 15:20:09 -0000

=== debian/control ===
Source: ros-kinetic-csm
Section: misc
Priority: extra
Maintainer: Isaac I.Y. Saito <130s@2000.jukuin.keio.ac.jp>
Build-Depends: debhelper (>= 9.0.0), cmake, libgsl-dev
Homepage: http://censi.mit.edu/software/csm
Standards-Version: 3.9.2

Package: ros-kinetic-csm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgsl-dev, ros-kinetic-catkin
Description: This is a ROS 3rd-party wrapper (see REP-136 for more detail) of Andrea Censi's CSM package.
 From the official website: The C(anonical) Scan Matcher (CSM) is a pure C implementation of a very fast variation of ICP using a point-to-line metric optimized for range-finder scan matching. It is robust enough to be used in industrial prototypes of autonomous mobile robotics, for example at Kuka. CSM is used by a variety of people, though it is hard to keep track because of the open source distribution, especially as packaged in ROS. If you use this software for something cool, let me know.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-csm//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
